/**********************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/
package org.eclipse.cosmos.rm.smlif.internal.common;

/**
 * Common constants used by multiple classes under
 * different packages.
 */
public class SMLConstants 
{
	
	public static final String XML_PREAMBLE = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>";
	public static final String BASE_URI_PREFIX = "http://cml.serviceml.org/";

	public static final String nl = "\n";
	public static final String tab = "\t";

	public static final String smlif_ext = ".smlif";

	public static final String LINE_SEPARATOR = System.getProperty("line.separator");

	public static StringBuffer smlifStart = new StringBuffer(XML_PREAMBLE).append(nl).append("<smlif:model").append(nl).append(tab).append("xmlns:smlif=\"http://schemas.serviceml.org/smlif/2006/10\"").append(nl).append(tab).append("xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\"").append(nl).append(tab).append("xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"").append(nl).append(tab).append("xsi:schemaLocation=\"http://schemas.serviceml.org/smlif/2006/10 smlif.xsd\">").append(nl).append(tab).append("<smlif:identity>");
	public static final StringBuffer smlifEnd = new StringBuffer("</smlif:model>");
	public static String genicsStart = new StringBuffer("<smlif:genics>").append(nl).toString();
	public static String phenicsStart = new StringBuffer("<smlif:phenics>").append(nl).toString();
	public static StringBuffer genicsEnd = new StringBuffer("</smlif:genics>").append(nl);
	public static StringBuffer phenicsEnd = new StringBuffer("</smlif:phenics>").append(nl);
	public static String ruleBindingsStart = new StringBuffer(tab).append("<smlif:ruleBindings>").append(nl).toString();
	public static StringBuffer ruleBindingsEnd = new StringBuffer(tab).append("</smlif:ruleBindings>").append(nl);
	public static String ruleBindingStart = new StringBuffer(tab).append(tab).append("<smlif:ruleBinding documentAlias=\"").toString(); 
	public static String ruleBindingMiddle = "\" ruleAlias=\""; 
	public static String ruleBindingEnd = new StringBuffer("\"/>").append(nl).toString(); 
	public static final StringBuffer docAliasesStart = new StringBuffer(nl).append("<smlif:document>").append(nl).append(tab).append("<smlif:docinfo>").append(nl).append(tab).append(tab).append("<smlif:aliases>");
	public static final StringBuffer docAliasStart = new StringBuffer(nl).append(tab).append(tab).append(tab).append("<smlif:alias>");
	public static final StringBuffer docAliasEnd = new StringBuffer("</smlif:alias>");
	public static final StringBuffer docAliasesEnd = new StringBuffer(nl).append(tab).append(tab).append("</smlif:aliases>").append(nl).append(tab).append("</smlif:docinfo>").append(nl).append(tab).append("<smlif:data>").append(nl);
	public static final StringBuffer docDataEnd = new StringBuffer(tab).append("</smlif:data>").append(nl).append("</smlif:document>").append(nl);
	
	/**
	 * Miscellaneous constants
	 */
	public static final String OPEN_ANGLE_BRACKET = "<";
	public static final String FORWARD_SLASH = "/";
	public static final String CLOSE_ANGLE_BRACKET = ">";
	public static final String SINGLE_SPACE = " ";
	public static final String EQUAL_SIGN = "=";
	public static final String DOUBLE_QUOTE = "\"";
}
