package org.eclipse.cosmos.rm.validation.internal.core;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Map;

import junit.framework.Test;

import org.eclipse.cosmos.rm.validation.internal.common.UtilityTester;
import org.eclipse.hyades.test.common.junit.DefaultTestArbiter;
import org.eclipse.hyades.test.common.junit.HyadesTestCase;
import org.eclipse.hyades.test.common.junit.HyadesTestSuite;

/**
 * Generated code for the test suite <b>TestMainValidator</b> located at
 * <i>/org.eclipse.cosmos.rm.validation.tests/junits/TestMainValidator.testsuite</i>.
 */
public class TestMainValidator extends HyadesTestCase
{
	/**
	 * Constructor for TestMainValidator.
	 * @param name
	 */
	public TestMainValidator(String name)
	{
		super(name);
	}

	/**
	 * Returns the JUnit test suite that implements the <b>TestMainValidator</b> definition.
	 */
	public static Test suite()
	{
		HyadesTestSuite testMainValidator = new HyadesTestSuite("TestMainValidator");
		testMainValidator.setArbiter(DefaultTestArbiter.INSTANCE).setId("F047EAA18640A2ED45B756708ECB11DB");
		testMainValidator.addTest(new TestMainValidator("testAcyclicInValidCycles").setId("CA88AFF1D7B860F5AAA9C99695FD11DB").setTestInvocationId("CA88AFF1D7B860F5F2BA460095FD11DB"));
		testMainValidator.addTest(new TestMainValidator("testAcyclicInValidDerivation").setId("CA88AFF1D7B860F5C545EBC095FD11DB").setTestInvocationId("CA88AFF1D7B860F5F2BD534095FD11DB"));
		testMainValidator.addTest(new TestMainValidator("testAcyclicValidCycles1").setId("CA88AFF1D7B860F5C545EBC495FD11DB").setTestInvocationId("CA88AFF1D7B860F5F2C0608095FD11DB"));
		testMainValidator.addTest(new TestMainValidator("testAcyclicValidCycles2").setId("CA88AFF1D7B860F5C545EBC895FD11DB").setTestInvocationId("CA88AFF1D7B860F5F2C36DC095FD11DB"));
		testMainValidator.addTest(new TestMainValidator("testAcyclicValidDerivation").setId("CA88AFF1D7B860F5C545EBCC95FD11DB").setTestInvocationId("CA88AFF1D7B860F5F2C67B0095FD11DB"));
		testMainValidator.addTest(new TestMainValidator("testTargetElementInValid").setId("FF95E1DED17414102637C6D08F8A11DB").setTestInvocationId("FF95E1DED17414106DFBD1008F8A11DB"));
		testMainValidator.addTest(new TestMainValidator("testTargetElementValid").setId("FF95E1DED174141046533A808F8A11DB").setTestInvocationId("FF95E1DED17414106DFEDE408F8A11DB"));
		testMainValidator.addTest(new TestMainValidator("testTargetElementValidSubGroup").setId("FF95E1DED17414104C0200608F8A11DB").setTestInvocationId("FF95E1DED17414106E01EB808F8A11DB"));
		testMainValidator.addTest(new TestMainValidator("testTargetElementInValidSubGroup").setId("FF95E1DED174141060CABDC08F8A11DB").setTestInvocationId("FF95E1DED17414106E0372208F8A11DB"));
		testMainValidator.addTest(new TestMainValidator("testTargetTypeInValid").setId("C0A2F02DCE78F07D8519B2E08F9311DB").setTestInvocationId("C0A2F02DCE78F07D9ED9CD008F9311DB"));
		testMainValidator.addTest(new TestMainValidator("testTargetTypeValid").setId("C0A2F02DCE78F07D8B6443908F9311DB").setTestInvocationId("C0A2F02DCE78F07D9EDE60E08F9311DB"));
		testMainValidator.addTest(new TestMainValidator("testTargetTypeInValidSubGroup").setId("C0A2F02DCE78F07D9109E1B08F9311DB").setTestInvocationId("C0A2F02DCE78F07D9EDFE7808F9311DB"));
		testMainValidator.addTest(new TestMainValidator("testTargetTypeValidSubGroup").setId("C0A2F02DCE78F07D9529CA308F9311DB").setTestInvocationId("C0A2F02DCE78F07D9EE2F4C08F9311DB"));
		testMainValidator.addTest(new TestMainValidator("testDrefMultipleNonRoot").setId("CA88AFF1D7B860F516622810963B11DB").setTestInvocationId("CA88AFF1D7B860F538FE0510963B11DB"));
		testMainValidator.addTest(new TestMainValidator("testDerefMultiple").setId("FF95E1DED17414100A89D1508F8811DB").setTestInvocationId("CA88AFF1D7B860F5390298F0963B11DB"));
		testMainValidator.addTest(new TestMainValidator("testDrefSingle").setId("CA88AFF1D7B860F516622814963B11DB").setTestInvocationId("CA88AFF1D7B860F539105490963B11DB"));
		testMainValidator.addTest(new TestMainValidator("testIdentityInValidKeyDuplicate").setId("CA88AFF1D7B860F507C340B095FE11DB").setTestInvocationId("CA88AFF1D7B860F54BADBA3095FE11DB"));
		testMainValidator.addTest(new TestMainValidator("testIdentityInValidKeyMissing").setId("CA88AFF1D7B860F519C9F7E095FE11DB").setTestInvocationId("CA88AFF1D7B860F54BB0C77095FE11DB"));
		testMainValidator.addTest(new TestMainValidator("testIdentityInValidUnique").setId("CA88AFF1D7B860F51FEFE99095FE11DB").setTestInvocationId("CA88AFF1D7B860F54BB3D4B095FE11DB"));
		testMainValidator.addTest(new TestMainValidator("testIdentityValidKeyref").setId("CA88AFF1D7B860F5260FC0C095FE11DB").setTestInvocationId("CA88AFF1D7B860F54BB55B5095FE11DB"));
		testMainValidator.addTest(new TestMainValidator("testIdentityValidKeyUnique").setId("CA88AFF1D7B860F537730C0095FE11DB").setTestInvocationId("CA88AFF1D7B860F54BB8689095FE11DB"));
		testMainValidator.addTest(new TestMainValidator("testIdentityValidKeyUniqueInScopeOnly").setId("CA88AFF1D7B860F53E85CEB095FE11DB").setTestInvocationId("CA88AFF1D7B860F54BBB75D095FE11DB"));
		testMainValidator.addTest(new TestMainValidator("testReferencesDanglingRef").setId("D14389B7B6BCE5E34EDAC4609A7611DB").setTestInvocationId("D14389B7B6BCE5E386E207609A7611DB"));
		testMainValidator.addTest(new TestMainValidator("testReferencesEmptyRefElement").setId("D14389B7B6BCE5E35732FF609A7611DB").setTestInvocationId("D14389B7B6BCE5E386E933509A7611DB"));
		testMainValidator.addTest(new TestMainValidator("testReferencesIntraDocumentRef").setId("D14389B7B6BCE5E3576C37D09A7611DB").setTestInvocationId("D14389B7B6BCE5E386EB7D409A7611DB"));
		testMainValidator.addTest(new TestMainValidator("testReferencesMultipleRefToAnElement").setId("D14389B7B6BCE5E3579989609A7611DB").setTestInvocationId("D14389B7B6BCE5E386EDEE409A7611DB"));
		testMainValidator.addTest(new TestMainValidator("testReferencesNullRefElement").setId("D14389B7B6BCE5E36200A7309A7611DB").setTestInvocationId("D14389B7B6BCE5E386F05F409A7611DB"));
		testMainValidator.addTest(new TestMainValidator("testReferencesRefToNonRootElement").setId("D14389B7B6BCE5E3621874F09A7611DB").setTestInvocationId("D14389B7B6BCE5E386F51A309A7611DB"));
		testMainValidator.addTest(new TestMainValidator("testReferencesRefToRootElement").setId("D14389B7B6BCE5E3624837809A7611DB").setTestInvocationId("D14389B7B6BCE5E386F78B309A7611DB"));
		testMainValidator.addTest(new TestMainValidator("testIncompleteInValid").setId("D14389B7B6BCE5E3C282B2D09B3C11DB").setTestInvocationId("D14389B7B6BCE5E3CF2D30F09B3C11DB"));		
		testMainValidator.addTest(new TestMainValidator("testTargetRequiredInValid").setId("F11989E62D62EDD9FAE831C09A9411DB").setTestInvocationId("F11989E62D62EDD94F276CB09A9511DB"));
		testMainValidator.addTest(new TestMainValidator("testTargetRequiredValidType").setId("F11989E62D62EDD9FDB7F3909A9411DB").setTestInvocationId("F11989E62D62EDD94F2A79F09A9511DB"));
		testMainValidator.addTest(new TestMainValidator("ttestTargetRequiredInValidType").setId("F11989E62D62EDD9012FB5309A9511DB").setTestInvocationId("F11989E62D62EDD94F2D87309A9511DB"));
		testMainValidator.addTest(new TestMainValidator("testTargetRequiredValidTypeFalse").setId("F11989E62D62EDD90781E7009A9511DB").setTestInvocationId("F11989E62D62EDD94F3094709A9511DB"));
		testMainValidator.addTest(new TestMainValidator("testTargetRequiredValidFalse").setId("F11989E62D62EDD919193A909A9511DB").setTestInvocationId("F11989E62D62EDD94F3528509A9511DB"));
		testMainValidator.addTest(new TestMainValidator("testTargetRequiredValidWithSubstitutionGroup").setId("F11989E62D62EDD91D8A02309A9511DB").setTestInvocationId("F11989E62D62EDD94F3835909A9511DB"));
		testMainValidator.addTest(new TestMainValidator("testTargetRequiredValidWithSubstitutionGroupFalseRequire").setId("F11989E62D62EDD92F893F509A9511DB").setTestInvocationId("F11989E62D62EDD94F3B42D09A9511DB"));
		testMainValidator.addTest(new TestMainValidator("testTargetRequiredInValidWithSubstitutionGroup").setId("F11989E62D62EDD93898E3709A9511DB").setTestInvocationId("F11989E62D62EDD94F3E50109A9511DB"));
		testMainValidator.addTest(new TestMainValidator("testRuleValid").setId("F11989E62D62EDD9105850B09AAB11DB").setTestInvocationId("F11989E62D62EDD92ECE2AB09AAB11DB"));
		testMainValidator.addTest(new TestMainValidator("testRuleInValid").setId("F11989E62D62EDD917698CC09AAB11DB").setTestInvocationId("F11989E62D62EDD92ED752709AAB11DB"));
		testMainValidator.addTest(new TestMainValidator("testRuleValidRuleBinding").setId("F11989E62D62EDD91C319C209AAB11DB").setTestInvocationId("F11989E62D62EDD92EDA5FB09AAB11DB"));
		testMainValidator.addTest(new TestMainValidator("testRuleInValidRuleBinding").setId("F11989E62D62EDD9250410309AAB11DB").setTestInvocationId("F11989E62D62EDD92EDD6CF09AAB11DB"));
		testMainValidator.addTest(new TestMainValidator("testTargetRequiredValid").setId("F11989E62D62EDD9F47754609A9411DB").setTestInvocationId("F11989E62D62EDD94F22D8D09A9511DB"));
		return testMainValidator;
	}

	/**
	 * @see junit.framework.TestCase#setUp()
	 */
	protected void setUp() throws Exception
	{
	}

	/**
	 * @see junit.framework.TestCase#tearDown()
	 */
	protected void tearDown() throws Exception
	{
	}
	
	private void startValidation(String document, final String OUTPUT) throws IOException
	{
		startValidation (document, OUTPUT, null, false);					
	}
	
	private void startValidation(String document, final String OUTPUT, final String EXPECTED) throws IOException
	{
		startValidation (document, OUTPUT, EXPECTED, true);
	}
	
	private void startValidation(String document, final String OUTPUT, final String EXPECTED, boolean compare) throws IOException
	{
		String documentPath = this.getClass().getClassLoader().getResource(document).getPath();
		documentPath = documentPath.replaceAll("%20", " ");
		MainValidator mainValidator = new MainValidator();
		Map attributes = mainValidator.getAttributes();
		attributes.put(IValidator.ATTRIBUTE_INSTANCE, documentPath);
		attributes.put(IValidator.ATTRIBUTE_FILE_OUTPUT, OUTPUT);
		mainValidator.start();
		
		if (compare)
			UtilityTester.compareFiles(EXPECTED, OUTPUT);
	}
	
	
	/**
	 * testAcyclicInValidCycles
	 * testInValidCycles
	 * @throws Exception
	 */
	public void testAcyclicInValidCycles() throws Exception
	{
		startValidation("test-resources/acyclic/InValidCycles.xml", "D:/temp/InvalidCycles.output", "expected-results/acyclic/InvalidCycles.output");
	}

	/**
	 * testAcyclicInValidDerivation
	 * testInValidDerivation
	 * @throws Exception
	 */
	public void testAcyclicInValidDerivation() throws Exception
	{
		startValidation("test-resources/acyclic/InValidDerivation.xml", "D:/temp/InValidDerivation.output", "expected-results/acyclic/InValidDerivation.output");
	}

	/**
	 * testAcyclicValidCycles1
	 * testValidCycles1
	 * @throws Exception
	 */
	public void testAcyclicValidCycles1() throws Exception
	{
		startValidation("test-resources/acyclic/ValidCycles1.xml", "D:/temp/ValidCycles1.output", "expected-results/common/empty.output");
	}

	/**
	 * testAcyclicValidCycles2
	 * testValidCycles2
	 * @throws Exception
	 */
	public void testAcyclicValidCycles2() throws Exception
	{
		startValidation("test-resources/acyclic/ValidCycles2.xml", "D:/temp/ValidCycles2.output", "expected-results/common/empty.output");
	}

	/**
	 * testAcyclicValidDerivation
	 * testValidDerivation
	 * @throws Exception
	 */
	public void testAcyclicValidDerivation() throws Exception
	{
		startValidation("test-resources/acyclic/ValidDerivation.xml", "D:/temp/ValidDerivation.output", "expected-results/common/empty.output");
	}

	/**
	 * testTargetElementInValid
	 * @throws Exception
	 */
	public void testTargetElementInValid() throws Exception {
		startValidation("test-resources/targetElement/InValid.xml", "D:/temp/testTargetElementInValid.output", "expected-results/targetElement/InValid.output");
	}

	/**
	 * testTargetElementValid
	 * @throws Exception
	 */
	public void testTargetElementValid() throws Exception {
		startValidation("test-resources/targetElement/valid.xml", "D:/temp/valid.output", "expected-results/common/empty.output");
	}

	/**
	 * testTargetElementValidSubGroup
	 * @throws Exception
	 */
	public void testTargetElementValidSubGroup() throws Exception {
		startValidation("test-resources/targetElement/ValidWithSubstitutionGroup.xml", "D:/temp/ValidWithSubstitutionGroup.output", "expected-results/common/empty.output");
	}

	/**
	 * testTargetElementInValidSubGroup
	 * @throws Exception
	 */
	public void testTargetElementInValidSubGroup() throws Exception {
		startValidation("test-resources/targetElement/InValidWithSubstitutionGroup.xml", "D:/temp/InValidWithSubstitutionGroup.output", "expected-results/targetElement/InValidWithSubstitutionGroup.output");
	}

	/**
	 * testTargetTypeInValid
	 * @throws Exception
	 */
	public void testTargetTypeInValid() throws Exception 
	{
		
		final String EXPECTED_LINE1 = "Severity: error Target Element Error: EnrolledGraduateCourse on line 89 column 52 references Course3 that is not of type tns:GraduateCourseType";
		final String EXPECTED_LINE2 = "Severity: error Target Element Error: EnrolledGraduateCourse on line 82 column 52 references Course1 that is not of type tns:GraduateCourseType";
		
		final String OUTPUT = "D:/temp/testTargetTypeInValid.output";
		startValidation("test-resources/targetType/InValid.xml", OUTPUT);
		BufferedReader br = new BufferedReader (new InputStreamReader(new FileInputStream(OUTPUT)));
		String line = br.readLine();
		if (!EXPECTED_LINE1.equals(line) && !EXPECTED_LINE2.equals(line))
			fail ("The output file does not contain either one of the expected lines");
	}

	/**
	 * testTargetTypeValid
	 * @throws Exception
	 */
	public void testTargetTypeValid() throws Exception {
		startValidation("test-resources/targetType/Valid.xml", "D:/temp/Valid.output", "expected-results/common/empty.output");
	}

	/**
	 * testTargetTypeInValidSubGroup
	 * @throws Exception
	 */
	public void testTargetTypeInValidSubGroup() throws Exception {
		startValidation("test-resources/targetType/InValidWithSubstitutionGroup.xml", "D:/temp/InValidWithSubstitutionGroup.output", "expected-results/targetType/InValidWithSubstitutionGroup.output");
	}

	/**
	 * testTargetTypeValidSubGroup
	 * @throws Exception
	 */
	public void testTargetTypeValidSubGroup() throws Exception {
		startValidation("test-resources/targetType/ValidWithSubstitutionGroup.xml", "D:/temp/ValidWithSubstitutionGroup.output", "expected-results/common/empty.output");
	}

	/**
	 * testDerefMultiple
	 * @throws Exception
	 */
	public void testDerefMultiple() throws Exception 
	{
		startValidation("test-resources/deref/Multiple.xml", "D:/temp/Multiple.output", "expected-results/common/empty.output");
	}
	
	/**
	 * testDrefMultipleNonRoot
	 * targetDrefMultipleNonRoot
	 * @throws Exception
	 */
	public void testDrefMultipleNonRoot() throws Exception 
	{
		startValidation("test-resources/deref/MultipleNonRoot.xml", "D:/temp/MultipleNonRoot.output", "expected-results/common/empty.output");
	}

	/**
	 * testDrefSingle
	 * targetDrefSingle
	 * @throws Exception
	 */
	public void testDrefSingle() throws Exception 
	{
		startValidation("test-resources/deref/Single.xml", "D:/temp/Single.output", "expected-results/common/empty.output");
	}

	/**
	 * testIdentityInValidKeyDuplicate
	 * @throws Exception
	 */
	public void testIdentityInValidKeyDuplicate() throws Exception
	{
		startValidation("test-resources/identity/InValidKeyDuplicate.xml", "D:/temp/testInvalidKeyDuplicate.output", "expected-results/identity/testInvalidKeyDuplicate.output");
	}

	/**
	 * testIdentityInValidKeyMissing
	 * @throws Exception
	 */
	public void testIdentityInValidKeyMissing() throws Exception
	{
		startValidation("test-resources/identity/InValidKeyMissing.xml", "D:/temp/testInvalidKeyMissing.output", "expected-results/identity/testInvalidKeyMissing.output");
	}

	/**
	 * testIdentityInValidUnique
	 * @throws Exception
	 */
	public void testIdentityInValidUnique() throws Exception
	{
		startValidation("test-resources/identity/InValidUnique.xml", "D:/temp/testInvalidUnique.output", "expected-results/identity/testInvalidUnique.output");
	}

	/**
	 * testIdentityValidKeyref
	 * @throws Exception
	 */
	public void testIdentityValidKeyref() throws Exception
	{
		startValidation("test-resources/identity/ValidKeyref.xml", "D:/temp/testIdentityValidKeyref.output", "expected-results/common/empty.output");
	}

	/**
	 * testIdentityValidKeyUnique
	 * @throws Exception
	 */
	public void testIdentityValidKeyUnique() throws Exception
	{
		startValidation("test-resources/identity/ValidKeyUnique.xml", "D:/temp/testIdentityValidKeyUnique.output", "expected-results/common/empty.output");
	}

	/**
	 * testIdentityValidKeyUniqueInScopeOnly
	 * @throws Exception
	 */
	public void testIdentityValidKeyUniqueInScopeOnly() throws Exception
	{
		startValidation("test-resources/identity/ValidKeyUniqueInScopeOnly.xml", "D:/temp/testIdentityValidKeyUniqueInScopeOnly.output", "expected-results/common/empty.output");
	}

	/**
	 * testReferencesDanglingRef
	 * @throws Exception
	 */
	public void testReferencesDanglingRef() throws Exception
	{
		startValidation("test-resources/references/DanglingRef.xml", "D:/temp/testReferencesDanglingRef.output", "expected-results/common/empty.output");
	}

	/**
	 * testReferencesEmptyRefElement
	 * @throws Exception
	 */
	public void testReferencesEmptyRefElement() throws Exception
	{
		startValidation("test-resources/references/EmptyRefElement.xml", "D:/temp/testReferencesEmptyRefElement.output", "expected-results/common/empty.output");
	}

	/**
	 * testReferencesIntraDocumentRef
	 * @throws Exception
	 */
	public void testReferencesIntraDocumentRef() throws Exception
	{
		startValidation("test-resources/references/IntraDocumentRef.xml", "D:/temp/testReferencesIntraDocumentRef.output", "expected-results/common/empty.output");
	}

	/**
	 * testReferencesMultipleRefToAnElement
	 * @throws Exception
	 */
	public void testReferencesMultipleRefToAnElement() throws Exception
	{
		startValidation("test-resources/references/MultipleRefToAnElement.xml", "D:/temp/testReferencesMultipleRefToAnElement.output", "expected-results/common/empty.output");
	}

	/**
	 * testReferencesNullRefElement
	 * @throws Exception
	 */
	public void testReferencesNullRefElement() throws Exception
	{
		startValidation("test-resources/references/NullRefElement.xml", "D:/temp/testReferencesNullRefElement.output", "expected-results/common/empty.output");
	}

	/**
	 * testReferencesRefToNonRootElement
	 * @throws Exception
	 */
	public void testReferencesRefToNonRootElement() throws Exception
	{
		startValidation("test-resources/references/RefToNonRootElement.xml", "D:/temp/testReferencesRefToNonRootElement.output", "expected-results/common/empty.output");
	}

	/**
	 * testReferencesRefToRootElement
	 * @throws Exception
	 */
	public void testReferencesRefToRootElement() throws Exception
	{
		startValidation("test-resources/references/RefToRootElement.xml", "D:/temp/testReferencesRefToRootElement.output", "expected-results/common/empty.output");
	}
	
	/**
	 * testTargetRequiredValid
	 * @throws Exception
	 */
	public void testTargetRequiredValid() throws Exception {
		startValidation("test-resources/targetRequired/valid.xml", "D:/temp/valid.output", "expected-results/common/empty.output");
	}

	/**
	 * testTargetRequiredInValid
	 * @throws Exception
	 */
	public void testTargetRequiredInValid() throws Exception {
		startValidation("test-resources/targetRequired/InValid.xml", "D:/temp/InValid.output", "expected-results/targetRequired/InValid.output");
	}

	/**
	 * testTargetRequiredValidType
	 * @throws Exception
	 */
	public void testTargetRequiredValidType() throws Exception {
		startValidation("test-resources/targetRequired/ValidType.xml", "D:/temp/ValidType.output", "expected-results/common/empty.output");
	}

	/**
	 * ttestTargetRequiredInValidType
	 * @throws Exception
	 */
	public void ttestTargetRequiredInValidType() throws Exception {
		startValidation("test-resources/targetRequired/InValidType.xml", "D:/temp/InValidType.output", "expected-results/targetRequired/InValidType.output");
	}

	/**
	 * testTargetRequiredValidTypeFalse
	 * @throws Exception
	 */
	public void testTargetRequiredValidTypeFalse() throws Exception {
		startValidation("test-resources/targetRequired/ValidTypeFalse.xml", "D:/temp/ValidTypeFalse.output", "expected-results/common/empty.output");
	}

	/**
	 * testTargetRequiredValidFalse
	 * @throws Exception
	 */
	public void testTargetRequiredValidFalse() throws Exception {
		startValidation("test-resources/targetRequired/ValidFalseRequire.xml", "D:/temp/ValidFalseRequire.output", "expected-results/common/empty.output");
	}

	/**
	 * testTargetRequiredValidWithSubstitutionGroup
	 * @throws Exception
	 */
	public void testTargetRequiredValidWithSubstitutionGroup() throws Exception {
		startValidation("test-resources/targetRequired/ValidWithSubstitutionGroup.xml", "D:/temp/ValidWithSubstitutionGroup.output", "expected-results/common/empty.output");
	}

	/**
	 * testTargetRequiredValidWithSubstitutionGroupFalseRequire
	 * @throws Exception
	 */
	public void testTargetRequiredValidWithSubstitutionGroupFalseRequire() throws Exception {
		startValidation("test-resources/targetRequired/ValidWithSubstitutionGroupFalseRequire.xml", "D:/temp/ValidWithSubstitutionGroupFalseRequire.output", "expected-results/common/empty.output");
	}

	/**
	 * testTargetRequiredInValidWithSubstitutionGroup
	 * @throws Exception
	 */
	public void testTargetRequiredInValidWithSubstitutionGroup() throws Exception {
		startValidation("test-resources/targetRequired/InValidWithSubstitutionGroup.xml", "D:/temp/InValidWithSubstitutionGroup.output", "expected-results/targetRequired/InValidWithSubstitutionGroup.output");
	}

	/**
	 * testRuleValid
	 * @throws Exception
	 */
	public void testRuleValid() throws Exception {
		startValidation("test-resources/rules/Valid.xml", "D:/temp/Valid.output", "expected-results/common/empty.output");
	}

	/**
	 * testRuleInValid
	 * @throws Exception
	 */
	public void testRuleInValid() throws Exception {
		startValidation("test-resources/rules/InValid.xml", "D:/temp/InValid.output", "expected-results/rules/InValid.output");
	}

	/**
	 * testRuleValidRuleBinding
	 * @throws Exception
	 */
	public void testRuleValidRuleBinding() throws Exception {
		startValidation("test-resources/rules/ValidRuleBinding.xml", "D:/temp/ValidRuleBinding.output", "expected-results/common/empty.output");
	}

	/**
	 * testRuleInValidRuleBinding
	 * @throws Exception
	 */
	public void testRuleInValidRuleBinding() throws Exception {
		startValidation("test-resources/rules/InValidRuleBinding.xml", "D:/temp/InValidRuleBinding.output", "expected-results/rules/InValidRuleBinding.output");
	}

	/**
	 * testIncompleteInValid
	 * @throws Exception
	 */
	public void testIncompleteInValid() throws Exception
	{
		startValidation("test-resources/incomplete/InValid.xml", "D:/temp/testIncompleteInValid.output", "expected-results/incomplete/InValid.output");
	}
}
